unit module;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, ExtCtrls, Variants, Math;

type
  TSegment = class(TCustomControl)
  private
    { Dclarations prives }
    nx,ny,a1x,a1y,a2x,a2y,b1x,b1y,b2x,b2y,amaxx,amaxy,aminx,aminy:integer;
    k:single;
    cad,cop,alp:extended;
    FFX1,FFX2,FFY1,FFY2, FX1,FX2,FY1,FY2:integer;
    FA1,FA2:Boolean;
    FCouleur,FCouleur2,FCouleur3 : TColor;
    Fetiq,FNum,FTpe,Find : string;
    procedure SetCouleur(Value : TColor);
    procedure SetCouleur2(Value : TColor);
    procedure SetCouleur3(Value : TColor);
    procedure SegClick(Sender:TObject);
    procedure SegClickDroit(Sender:TObject; MousePos:TPoint;var Handled:Boolean);
    procedure SegSouris(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Grave(st:string);
  protected
    { Dclarations protges }
    procedure Paint; override;
  public
    { Dclarations publiques }
    constructor Create ( AOwner : TComponent); override;
    destructor Destroy; override;
  published
    { Dclarations publies }
    property OnClick;
    Property X1 : integer read FFX1 write FFX1;
    property X2 : integer read FFX2 write FFX2;
    property Y1 : integer read FFY1 write FFY1;
    property Y2 : integer read FFY2 write FFY2;
    property A1 : boolean read FA1 write FA1;
    property A2 : boolean read FA2 write FA2;
    property NumId : string read FNum write FNum;
    property Tpe : string read FTpe write FTpe;
    property Etiq : string read Fetiq write Fetiq;
    Property Indice : string read Find write Find;
    property Couleur: TColor read FCouleur write SetCouleur;
    property CouleurLabel: TColor read FCouleur2 write SetCouleur2;
    property CouleurLigne: TColor read FCouleur3 write SetCouleur3;
    procedure Formate;
  end; // TSegment

implementation

uses Unit1;

constructor TSegment.Create ( AOwner : TComponent);
begin
  inherited Create ( AOwner);
  color:=clBlue;
  Cursor:=crHandPoint;
  FCouleur:=clBlue;
  FCouleur2:=clBlue;
  FCouleur3:=clBlue;
  FNum:='';
  FA1:=true;
  FA2:=true;
  ShowHint:= true;
  Parent:=Form1.ScrollBox1;
  OnClick:=SegClick;
  OnContextPopup:=SegClickDroit;
  OnMouseMove:=SegSouris;
end;

destructor TSegment.Destroy;
begin
  inherited Destroy;
end;

procedure TSegment.Formate;    // calcule le cadre
var frmRegion, frmRegion1, tempRegion : HRGN;
    diamant:array [1..4] of TPoint;
    q1x,q2x,q1y,q2y,qi:integer;
begin
  FX1:=round((kd-3)/3*FFX1); FX2:=round((kd-3)/3*FFX2);
  FY1:=round((kd-3)/3*FFY1); FY2:=round((kd-3)/3*FFY2);

  cad:=(FX2-FX1);  cop:=(FY1-FY2);

  if cad=0 then alp:=90 else alp:=arctan(cop/cad)*180/pi;
  if cad<0 then alp:=alp+180;
  k:=2*sqrt(sqr(cad)+sqr(cop))/kd+0.01;

  nx:=round(cop/k);  ny:=round(cad/k);
  qi:=round(kd/2);

  aminx:=min(FX1,FX2)-qi;
  amaxx:=max(FX1,FX2)+qi;
  aminy:=min(FY1,FY2)-qi;
  amaxy:=max(FY1,FY2)+qi;

  a1x:=FX1+nx-aminx;
  a1y:=FY1+ny-aminy;
  a2x:=FX1-nx-aminx;
  a2y:=FY1-ny-aminy;
  b1x:=FX2+nx-aminx;
  b1y:=FY2+ny-aminy;
  b2x:=FX2-nx-aminx;
  b2y:=FY2-ny-aminy;
  Left:=aminx;        Top:=aminy;
  Width:=amaxx-aminx; Height:=amaxy-aminy;
  diamant[1].x:= a1x; diamant[1].y:= a1y;
  diamant[2].x:= a2x; diamant[2].y:= a2y;
  diamant[3].x:= b2x; diamant[3].y:= b2y;
  diamant[4].x:= b1x; diamant[4].y:= b1y;
  frmRegion := CreatePolygonRgn(diamant,4,WINDING);
  if not FA1 then begin
    q1x:=FX1-aminx+qi+1; q2x:=FX1-aminx-qi;
    q1y:=FY1-aminy-qi;   q2y:=FY1-aminy+qi+1;
    frmRegion1 := CreateEllipticRgn(q1x,q1y,q2x,q2y);
    CombineRgn( frmRegion, frmRegion, frmRegion1, RGN_OR );
    DeleteObject(frmRegion1);
  end;
  if not FA2 then begin
    q1x:=FX2-aminx+qi+1; q2x:=FX2-aminx-qi;
    q1y:=FY2-aminy-qi;   q2y:=FY2-aminy+qi+1;
    frmRegion1 := CreateEllipticRgn(q1x,q1y,q2x,q2y);
    CombineRgn( frmRegion, frmRegion, frmRegion1, RGN_OR );
    DeleteObject(frmRegion1);
  end;
  tempregion := CreateRectRgn( 0, 0, width, height);
  CombineRgn( frmRegion, frmRegion, tempRegion, RGN_AND );
  DeleteObject( tempRegion );
  SetWindowRgn( Handle, frmRegion, true );
  DeleteObject(frmRegion);
  Paint;
end;

procedure TSegment.Paint;
begin
  Canvas.Pen.Width:=round(kd/4);
  Canvas.Pen.Color:=FCouleur3;
  Canvas.MoveTo(round((a1x+a2x)/2),round((a1y+a2y)/2));
  Canvas.LineTo(round((b1x+b2x)/2),round((b1y+b2y)/2));
  Canvas.Pen.Width:=1;
  Canvas.Pen.Color:=Form1.ScrollBox1.Color;
  if FA1 then Canvas.Polyline ([Point(a1x,a1y), Point(a2x,a2y),Point(a1x,a1y)]);
  if FA2 then Canvas.Polyline ([Point(b1x,b1y), Point(b2x,b2y),Point(b1x,b1y)]);
  Grave(Etiq);
end;

procedure TSegment.SetCouleur(Value : TColor);
begin
  if Value<>FCouleur then begin
    FCouleur:=Value;
    color:=Value;
    Refresh;
  end;
end;

procedure TSegment.SetCouleur2(Value : TColor);
begin
  if Value<>FCouleur2 then begin
    FCouleur2:=Value;
    Refresh;
  end;
end;
procedure TSegment.SetCouleur3(Value : TColor);
begin
  if Value<>FCouleur3 then begin
    FCouleur3:=Value;
    Refresh;
  end;
end;

procedure TSegment.SegClick(Sender:TObject);
begin
  Form1.SegmentClick(Sender);
end;

procedure TSegment.SegClickDroit(Sender:TObject; MousePos:TPoint;var Handled:Boolean);
begin
  Form1.SegmentClickDroit(Sender);
end;

procedure TSegment.SegSouris(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  Form1.SegmentSouris(Sender);
end;

procedure TSegment.grave(st:string);
var
 // OldFont: TFont;   //
  NewFont: THandle;
  LogFont: TLogFont;
  x,y,a,i:integer;
begin
  if st<>'' then begin
//  OldFont := TFont.Create;
//  OldFont.Assign(Canvas.Font); {Sauvetage de la police de caractre actuelle}
  a:=round(10*alp);
  x:=round((a2x+b2x-canvas.TextWidth(st)/2)/2);
  y:=round((a2y+b2y)/2);
  if b2x=a2x then begin
    x:=round((a2x+b2x)/2);
  end else y:=round((b2y-a2y)/(b2x-a2x)*(x-a2x)+a2y)-1;
{Cration d'une nouvelle police de caractre}
  Canvas.Brush.Color:=FCouleur2;
  Canvas.Font.Color:=clWhite;
  if (FCouleur2=clYellow) or (FCouleur2=rgb(255,255,190)) or (FCouleur2=rgb(160,255,160)) then Canvas.Font.Color:=clBlack;
  i:=1;
  if a=0 then i:=2;
  LogFont.lfHeight := kd+i;
  LogFont.lfWidth := 0; {on laisse le choix  'Font Mapper'}
  LogFont.lfEscapement := a; {angle d'inclinaison, en dixime de degr}
  LogFont.lfOrientation := 0 ;
  LogFont.lfWeight := FW_BOLD; {ou FW_BOLD}
  LogFont.lfItalic := 0;{0 = pas d'italique, 1 = italique}
  LogFont.lfUnderline := 0;{0 = pas soulign, 1 = soulign}
  LogFont.lfStrikeout := 0;{0 = pas barr, 1 = barr}
  LogFont.lfCharSet := ANSI_CHARSET; {par dfaut}
  LogFont.lfOutPrecision := 7;//OUT_TT_ONLY_PRECIS;{force le 'True Type'}
  LogFont.lfClipPrecision := 0;//CLIP_DEFAULT_PRECIS;{par dfaut}
  LogFont.lfQuality := 4;
  LogFont.lfPitchAndFamily := Variable_Pitch;{par dfaut}
  StrPCopy(LogFont.lfFaceName, 'PoliceInclinee');
  NewFont := CreateFontIndirect(LogFont);
  Canvas.Font.Handle := NewFont; {Assignation de la nouvelle police de caractre au canvas de la fiche}
  Canvas.TextOut(x,y,' '+st+' ');
  //  Canvas.Font.Assign(OldFont); {rcupration de la police de caractre originale}
  DeleteObject(NewFont); {destruction de la nouvelle police de caractre}
  end; // if st
end;

end.
